﻿library winmm;

uses
  Winapi.Windows, DDetours;

{$IMAGEBASE $4F0B0000}

var
  hLib: THandle;
  p_CloseDriver: Pointer;
  p_DefDriverProc: Pointer;
  p_DriverCallback: Pointer;
  p_DrvGetModuleHandle: Pointer;
  p_GetDriverModuleHandle: Pointer;
  p_NotifyCallbackData: Pointer;
  p_OpenDriver: Pointer;
  p_PlaySound: Pointer;
  p_PlaySoundA: Pointer;
  p_PlaySoundW: Pointer;
  p_SendDriverMessage: Pointer;
  p_WOW32DriverCallback: Pointer;
  p_WOW32ResolveMultiMediaHandle: Pointer;
  p_WOWAppExit: Pointer;
  p_aux32Message: Pointer;
  p_auxGetDevCapsA: Pointer;
  p_auxGetDevCapsW: Pointer;
  p_auxGetNumDevs: Pointer;
  p_auxGetVolume: Pointer;
  p_auxOutMessage: Pointer;
  p_auxSetVolume: Pointer;
  p_joy32Message: Pointer;
  p_joyConfigChanged: Pointer;
  p_joyGetDevCapsA: Pointer;
  p_joyGetDevCapsW: Pointer;
  p_joyGetNumDevs: Pointer;
  p_joyGetPos: Pointer;
  p_joyGetPosEx: Pointer;
  p_joyGetThreshold: Pointer;
  p_joyReleaseCapture: Pointer;
  p_joySetCapture: Pointer;
  p_joySetThreshold: Pointer;
  p_mci32Message: Pointer;
  p_mciDriverNotify: Pointer;
  p_mciDriverYield: Pointer;
  p_mciExecute: Pointer;
  p_mciFreeCommandResource: Pointer;
  p_mciGetCreatorTask: Pointer;
  p_mciGetDeviceIDA: Pointer;
  p_mciGetDeviceIDFromElementIDA: Pointer;
  p_mciGetDeviceIDFromElementIDW: Pointer;
  p_mciGetDeviceIDW: Pointer;
  p_mciGetDriverData: Pointer;
  p_mciGetErrorStringA: Pointer;
  p_mciGetErrorStringW: Pointer;
  p_mciGetYieldProc: Pointer;
  p_mciLoadCommandResource: Pointer;
  p_mciSendCommandA: Pointer;
  p_mciSendCommandW: Pointer;
  p_mciSendStringA: Pointer;
  p_mciSendStringW: Pointer;
  p_mciSetDriverData: Pointer;
  p_mciSetYieldProc: Pointer;
  p_mid32Message: Pointer;
  p_midiConnect: Pointer;
  p_midiDisconnect: Pointer;
  p_midiInAddBuffer: Pointer;
  p_midiInClose: Pointer;
  p_midiInGetDevCapsA: Pointer;
  p_midiInGetDevCapsW: Pointer;
  p_midiInGetErrorTextA: Pointer;
  p_midiInGetErrorTextW: Pointer;
  p_midiInGetID: Pointer;
  p_midiInGetNumDevs: Pointer;
  p_midiInMessage: Pointer;
  p_midiInOpen: Pointer;
  p_midiInPrepareHeader: Pointer;
  p_midiInReset: Pointer;
  p_midiInStart: Pointer;
  p_midiInStop: Pointer;
  p_midiInUnprepareHeader: Pointer;
  p_midiOutCacheDrumPatches: Pointer;
  p_midiOutCachePatches: Pointer;
  p_midiOutClose: Pointer;
  p_midiOutGetDevCapsA: Pointer;
  p_midiOutGetDevCapsW: Pointer;
  p_midiOutGetErrorTextA: Pointer;
  p_midiOutGetErrorTextW: Pointer;
  p_midiOutGetID: Pointer;
  p_midiOutGetNumDevs: Pointer;
  p_midiOutGetVolume: Pointer;
  p_midiOutLongMsg: Pointer;
  p_midiOutMessage: Pointer;
  p_midiOutOpen: Pointer;
  p_midiOutPrepareHeader: Pointer;
  p_midiOutReset: Pointer;
  p_midiOutSetVolume: Pointer;
  p_midiOutShortMsg: Pointer;
  p_midiOutUnprepareHeader: Pointer;
  p_midiStreamClose: Pointer;
  p_midiStreamOpen: Pointer;
  p_midiStreamOut: Pointer;
  p_midiStreamPause: Pointer;
  p_midiStreamPosition: Pointer;
  p_midiStreamProperty: Pointer;
  p_midiStreamRestart: Pointer;
  p_midiStreamStop: Pointer;
  p_mixerClose: Pointer;
  p_mixerGetControlDetailsA: Pointer;
  p_mixerGetControlDetailsW: Pointer;
  p_mixerGetDevCapsA: Pointer;
  p_mixerGetDevCapsW: Pointer;
  p_mixerGetID: Pointer;
  p_mixerGetLineControlsA: Pointer;
  p_mixerGetLineControlsW: Pointer;
  p_mixerGetLineInfoA: Pointer;
  p_mixerGetLineInfoW: Pointer;
  p_mixerGetNumDevs: Pointer;
  p_mixerMessage: Pointer;
  p_mixerOpen: Pointer;
  p_mixerSetControlDetails: Pointer;
  p_mmDrvInstall: Pointer;
  p_mmGetCurrentTask: Pointer;
  p_mmTaskBlock: Pointer;
  p_mmTaskCreate: Pointer;
  p_mmTaskSignal: Pointer;
  p_mmTaskYield: Pointer;
  p_mmioAdvance: Pointer;
  p_mmioAscend: Pointer;
  p_mmioClose: Pointer;
  p_mmioCreateChunk: Pointer;
  p_mmioDescend: Pointer;
  p_mmioFlush: Pointer;
  p_mmioGetInfo: Pointer;
  p_mmioInstallIOProcA: Pointer;
  p_mmioInstallIOProcW: Pointer;
  p_mmioOpenA: Pointer;
  p_mmioOpenW: Pointer;
  p_mmioRead: Pointer;
  p_mmioRenameA: Pointer;
  p_mmioRenameW: Pointer;
  p_mmioSeek: Pointer;
  p_mmioSendMessage: Pointer;
  p_mmioSetBuffer: Pointer;
  p_mmioSetInfo: Pointer;
  p_mmioStringToFOURCCA: Pointer;
  p_mmioStringToFOURCCW: Pointer;
  p_mmioWrite: Pointer;
  p_mmsystemGetVersion: Pointer;
  p_mod32Message: Pointer;
  p_mxd32Message: Pointer;
  p_sndPlaySoundA: Pointer;
  p_sndPlaySoundW: Pointer;
  p_tid32Message: Pointer;
  p_timeBeginPeriod: Pointer;
  p_timeEndPeriod: Pointer;
  p_timeGetDevCaps: Pointer;
  p_timeGetSystemTime: Pointer;
  p_timeGetTime: Pointer;
  p_timeKillEvent: Pointer;
  p_timeSetEvent: Pointer;
  p_waveInAddBuffer: Pointer;
  p_waveInClose: Pointer;
  p_waveInGetDevCapsA: Pointer;
  p_waveInGetDevCapsW: Pointer;
  p_waveInGetErrorTextA: Pointer;
  p_waveInGetErrorTextW: Pointer;
  p_waveInGetID: Pointer;
  p_waveInGetNumDevs: Pointer;
  p_waveInGetPosition: Pointer;
  p_waveInMessage: Pointer;
  p_waveInOpen: Pointer;
  p_waveInPrepareHeader: Pointer;
  p_waveInReset: Pointer;
  p_waveInStart: Pointer;
  p_waveInStop: Pointer;
  p_waveInUnprepareHeader: Pointer;
  p_waveOutBreakLoop: Pointer;
  p_waveOutClose: Pointer;
  p_waveOutGetDevCapsA: Pointer;
  p_waveOutGetDevCapsW: Pointer;
  p_waveOutGetErrorTextA: Pointer;
  p_waveOutGetErrorTextW: Pointer;
  p_waveOutGetID: Pointer;
  p_waveOutGetNumDevs: Pointer;
  p_waveOutGetPitch: Pointer;
  p_waveOutGetPlaybackRate: Pointer;
  p_waveOutGetPosition: Pointer;
  p_waveOutGetVolume: Pointer;
  p_waveOutMessage: Pointer;
  p_waveOutOpen: Pointer;
  p_waveOutPause: Pointer;
  p_waveOutPrepareHeader: Pointer;
  p_waveOutReset: Pointer;
  p_waveOutRestart: Pointer;
  p_waveOutSetPitch: Pointer;
  p_waveOutSetPlaybackRate: Pointer;
  p_waveOutSetVolume: Pointer;
  p_waveOutUnprepareHeader: Pointer;
  p_waveOutWrite: Pointer;
  p_wid32Message: Pointer;
  p_wod32Message: Pointer;

procedure CloseDriver; asm JMP [p_CloseDriver] end;
procedure DefDriverProc; asm JMP [p_DefDriverProc] end;
procedure DriverCallback; asm JMP [p_DriverCallback] end;
procedure DrvGetModuleHandle; asm JMP [p_DrvGetModuleHandle] end;
procedure GetDriverModuleHandle; asm JMP [p_GetDriverModuleHandle] end;
procedure NotifyCallbackData; asm JMP [p_NotifyCallbackData] end;
procedure OpenDriver; asm JMP [p_OpenDriver] end;
procedure PlaySound; asm JMP [p_PlaySound] end;
procedure PlaySoundA; asm JMP [p_PlaySoundA] end;
procedure PlaySoundW; asm JMP [p_PlaySoundW] end;
procedure SendDriverMessage; asm JMP [p_SendDriverMessage] end;
procedure WOW32DriverCallback; asm JMP [p_WOW32DriverCallback] end;
procedure WOW32ResolveMultiMediaHandle; asm JMP [p_WOW32ResolveMultiMediaHandle] end;
procedure WOWAppExit; asm JMP [p_WOWAppExit] end;
procedure aux32Message; asm JMP [p_aux32Message] end;
procedure auxGetDevCapsA; asm JMP [p_auxGetDevCapsA] end;
procedure auxGetDevCapsW; asm JMP [p_auxGetDevCapsW] end;
procedure auxGetNumDevs; asm JMP [p_auxGetNumDevs] end;
procedure auxGetVolume; asm JMP [p_auxGetVolume] end;
procedure auxOutMessage; asm JMP [p_auxOutMessage] end;
procedure auxSetVolume; asm JMP [p_auxSetVolume] end;
procedure joy32Message; asm JMP [p_joy32Message] end;
procedure joyConfigChanged; asm JMP [p_joyConfigChanged] end;
procedure joyGetDevCapsA; asm JMP [p_joyGetDevCapsA] end;
procedure joyGetDevCapsW; asm JMP [p_joyGetDevCapsW] end;
procedure joyGetNumDevs; asm JMP [p_joyGetNumDevs] end;
procedure joyGetPos; asm JMP [p_joyGetPos] end;
procedure joyGetPosEx; asm JMP [p_joyGetPosEx] end;
procedure joyGetThreshold; asm JMP [p_joyGetThreshold] end;
procedure joyReleaseCapture; asm JMP [p_joyReleaseCapture] end;
procedure joySetCapture; asm JMP [p_joySetCapture] end;
procedure joySetThreshold; asm JMP [p_joySetThreshold] end;
procedure mci32Message; asm JMP [p_mci32Message] end;
procedure mciDriverNotify; asm JMP [p_mciDriverNotify] end;
procedure mciDriverYield; asm JMP [p_mciDriverYield] end;
procedure mciExecute; asm JMP [p_mciExecute] end;
procedure mciFreeCommandResource; asm JMP [p_mciFreeCommandResource] end;
procedure mciGetCreatorTask; asm JMP [p_mciGetCreatorTask] end;
procedure mciGetDeviceIDA; asm JMP [p_mciGetDeviceIDA] end;
procedure mciGetDeviceIDFromElementIDA; asm JMP [p_mciGetDeviceIDFromElementIDA] end;
procedure mciGetDeviceIDFromElementIDW; asm JMP [p_mciGetDeviceIDFromElementIDW] end;
procedure mciGetDeviceIDW; asm JMP [p_mciGetDeviceIDW] end;
procedure mciGetDriverData; asm JMP [p_mciGetDriverData] end;
procedure mciGetErrorStringA; asm JMP [p_mciGetErrorStringA] end;
procedure mciGetErrorStringW; asm JMP [p_mciGetErrorStringW] end;
procedure mciGetYieldProc; asm JMP [p_mciGetYieldProc] end;
procedure mciLoadCommandResource; asm JMP [p_mciLoadCommandResource] end;
procedure mciSendCommandA; asm JMP [p_mciSendCommandA] end;
procedure mciSendCommandW; asm JMP [p_mciSendCommandW] end;
procedure mciSendStringA; asm JMP [p_mciSendStringA] end;
procedure mciSendStringW; asm JMP [p_mciSendStringW] end;
procedure mciSetDriverData; asm JMP [p_mciSetDriverData] end;
procedure mciSetYieldProc; asm JMP [p_mciSetYieldProc] end;
procedure mid32Message; asm JMP [p_mid32Message] end;
procedure midiConnect; asm JMP [p_midiConnect] end;
procedure midiDisconnect; asm JMP [p_midiDisconnect] end;
procedure midiInAddBuffer; asm JMP [p_midiInAddBuffer] end;
procedure midiInClose; asm JMP [p_midiInClose] end;
procedure midiInGetDevCapsA; asm JMP [p_midiInGetDevCapsA] end;
procedure midiInGetDevCapsW; asm JMP [p_midiInGetDevCapsW] end;
procedure midiInGetErrorTextA; asm JMP [p_midiInGetErrorTextA] end;
procedure midiInGetErrorTextW; asm JMP [p_midiInGetErrorTextW] end;
procedure midiInGetID; asm JMP [p_midiInGetID] end;
procedure midiInGetNumDevs; asm JMP [p_midiInGetNumDevs] end;
procedure midiInMessage; asm JMP [p_midiInMessage] end;
procedure midiInOpen; asm JMP [p_midiInOpen] end;
procedure midiInPrepareHeader; asm JMP [p_midiInPrepareHeader] end;
procedure midiInReset; asm JMP [p_midiInReset] end;
procedure midiInStart; asm JMP [p_midiInStart] end;
procedure midiInStop; asm JMP [p_midiInStop] end;
procedure midiInUnprepareHeader; asm JMP [p_midiInUnprepareHeader] end;
procedure midiOutCacheDrumPatches; asm JMP [p_midiOutCacheDrumPatches] end;
procedure midiOutCachePatches; asm JMP [p_midiOutCachePatches] end;
procedure midiOutClose; asm JMP [p_midiOutClose] end;
procedure midiOutGetDevCapsA; asm JMP [p_midiOutGetDevCapsA] end;
procedure midiOutGetDevCapsW; asm JMP [p_midiOutGetDevCapsW] end;
procedure midiOutGetErrorTextA; asm JMP [p_midiOutGetErrorTextA] end;
procedure midiOutGetErrorTextW; asm JMP [p_midiOutGetErrorTextW] end;
procedure midiOutGetID; asm JMP [p_midiOutGetID] end;
procedure midiOutGetNumDevs; asm JMP [p_midiOutGetNumDevs] end;
procedure midiOutGetVolume; asm JMP [p_midiOutGetVolume] end;
procedure midiOutLongMsg; asm JMP [p_midiOutLongMsg] end;
procedure midiOutMessage; asm JMP [p_midiOutMessage] end;
procedure midiOutOpen; asm JMP [p_midiOutOpen] end;
procedure midiOutPrepareHeader; asm JMP [p_midiOutPrepareHeader] end;
procedure midiOutReset; asm JMP [p_midiOutReset] end;
procedure midiOutSetVolume; asm JMP [p_midiOutSetVolume] end;
procedure midiOutShortMsg; asm JMP [p_midiOutShortMsg] end;
procedure midiOutUnprepareHeader; asm JMP [p_midiOutUnprepareHeader] end;
procedure midiStreamClose; asm JMP [p_midiStreamClose] end;
procedure midiStreamOpen; asm JMP [p_midiStreamOpen] end;
procedure midiStreamOut; asm JMP [p_midiStreamOut] end;
procedure midiStreamPause; asm JMP [p_midiStreamPause] end;
procedure midiStreamPosition; asm JMP [p_midiStreamPosition] end;
procedure midiStreamProperty; asm JMP [p_midiStreamProperty] end;
procedure midiStreamRestart; asm JMP [p_midiStreamRestart] end;
procedure midiStreamStop; asm JMP [p_midiStreamStop] end;
procedure mixerClose; asm JMP [p_mixerClose] end;
procedure mixerGetControlDetailsA; asm JMP [p_mixerGetControlDetailsA] end;
procedure mixerGetControlDetailsW; asm JMP [p_mixerGetControlDetailsW] end;
procedure mixerGetDevCapsA; asm JMP [p_mixerGetDevCapsA] end;
procedure mixerGetDevCapsW; asm JMP [p_mixerGetDevCapsW] end;
procedure mixerGetID; asm JMP [p_mixerGetID] end;
procedure mixerGetLineControlsA; asm JMP [p_mixerGetLineControlsA] end;
procedure mixerGetLineControlsW; asm JMP [p_mixerGetLineControlsW] end;
procedure mixerGetLineInfoA; asm JMP [p_mixerGetLineInfoA] end;
procedure mixerGetLineInfoW; asm JMP [p_mixerGetLineInfoW] end;
procedure mixerGetNumDevs; asm JMP [p_mixerGetNumDevs] end;
procedure mixerMessage; asm JMP [p_mixerMessage] end;
procedure mixerOpen; asm JMP [p_mixerOpen] end;
procedure mixerSetControlDetails; asm JMP [p_mixerSetControlDetails] end;
procedure mmDrvInstall; asm JMP [p_mmDrvInstall] end;
procedure mmGetCurrentTask; asm JMP [p_mmGetCurrentTask] end;
procedure mmTaskBlock; asm JMP [p_mmTaskBlock] end;
procedure mmTaskCreate; asm JMP [p_mmTaskCreate] end;
procedure mmTaskSignal; asm JMP [p_mmTaskSignal] end;
procedure mmTaskYield; asm JMP [p_mmTaskYield] end;
procedure mmioAdvance; asm JMP [p_mmioAdvance] end;
procedure mmioAscend; asm JMP [p_mmioAscend] end;
procedure mmioClose; asm JMP [p_mmioClose] end;
procedure mmioCreateChunk; asm JMP [p_mmioCreateChunk] end;
procedure mmioDescend; asm JMP [p_mmioDescend] end;
procedure mmioFlush; asm JMP [p_mmioFlush] end;
procedure mmioGetInfo; asm JMP [p_mmioGetInfo] end;
procedure mmioInstallIOProcA; asm JMP [p_mmioInstallIOProcA] end;
procedure mmioInstallIOProcW; asm JMP [p_mmioInstallIOProcW] end;
procedure mmioOpenA; asm JMP [p_mmioOpenA] end;
procedure mmioOpenW; asm JMP [p_mmioOpenW] end;
procedure mmioRead; asm JMP [p_mmioRead] end;
procedure mmioRenameA; asm JMP [p_mmioRenameA] end;
procedure mmioRenameW; asm JMP [p_mmioRenameW] end;
procedure mmioSeek; asm JMP [p_mmioSeek] end;
procedure mmioSendMessage; asm JMP [p_mmioSendMessage] end;
procedure mmioSetBuffer; asm JMP [p_mmioSetBuffer] end;
procedure mmioSetInfo; asm JMP [p_mmioSetInfo] end;
procedure mmioStringToFOURCCA; asm JMP [p_mmioStringToFOURCCA] end;
procedure mmioStringToFOURCCW; asm JMP [p_mmioStringToFOURCCW] end;
procedure mmioWrite; asm JMP [p_mmioWrite] end;
procedure mmsystemGetVersion; asm JMP [p_mmsystemGetVersion] end;
procedure mod32Message; asm JMP [p_mod32Message] end;
procedure mxd32Message; asm JMP [p_mxd32Message] end;
procedure sndPlaySoundA; asm JMP [p_sndPlaySoundA] end;
procedure sndPlaySoundW; asm JMP [p_sndPlaySoundW] end;
procedure tid32Message; asm JMP [p_tid32Message] end;
procedure timeBeginPeriod; asm JMP [p_timeBeginPeriod] end;
procedure timeEndPeriod; asm JMP [p_timeEndPeriod] end;
procedure timeGetDevCaps; asm JMP [p_timeGetDevCaps] end;
procedure timeGetSystemTime; asm JMP [p_timeGetSystemTime] end;
procedure timeGetTime; asm JMP [p_timeGetTime] end;
procedure timeKillEvent; asm JMP [p_timeKillEvent] end;
procedure timeSetEvent; asm JMP [p_timeSetEvent] end;
procedure waveInAddBuffer; asm JMP [p_waveInAddBuffer] end;
procedure waveInClose; asm JMP [p_waveInClose] end;
procedure waveInGetDevCapsA; asm JMP [p_waveInGetDevCapsA] end;
procedure waveInGetDevCapsW; asm JMP [p_waveInGetDevCapsW] end;
procedure waveInGetErrorTextA; asm JMP [p_waveInGetErrorTextA] end;
procedure waveInGetErrorTextW; asm JMP [p_waveInGetErrorTextW] end;
procedure waveInGetID; asm JMP [p_waveInGetID] end;
procedure waveInGetNumDevs; asm JMP [p_waveInGetNumDevs] end;
procedure waveInGetPosition; asm JMP [p_waveInGetPosition] end;
procedure waveInMessage; asm JMP [p_waveInMessage] end;
procedure waveInOpen; asm JMP [p_waveInOpen] end;
procedure waveInPrepareHeader; asm JMP [p_waveInPrepareHeader] end;
procedure waveInReset; asm JMP [p_waveInReset] end;
procedure waveInStart; asm JMP [p_waveInStart] end;
procedure waveInStop; asm JMP [p_waveInStop] end;
procedure waveInUnprepareHeader; asm JMP [p_waveInUnprepareHeader] end;
procedure waveOutBreakLoop; asm JMP [p_waveOutBreakLoop] end;
procedure waveOutClose; asm JMP [p_waveOutClose] end;
procedure waveOutGetDevCapsA; asm JMP [p_waveOutGetDevCapsA] end;
procedure waveOutGetDevCapsW; asm JMP [p_waveOutGetDevCapsW] end;
procedure waveOutGetErrorTextA; asm JMP [p_waveOutGetErrorTextA] end;
procedure waveOutGetErrorTextW; asm JMP [p_waveOutGetErrorTextW] end;
procedure waveOutGetID; asm JMP [p_waveOutGetID] end;
procedure waveOutGetNumDevs; asm JMP [p_waveOutGetNumDevs] end;
procedure waveOutGetPitch; asm JMP [p_waveOutGetPitch] end;
procedure waveOutGetPlaybackRate; asm JMP [p_waveOutGetPlaybackRate] end;
procedure waveOutGetPosition; asm JMP [p_waveOutGetPosition] end;
procedure waveOutGetVolume; asm JMP [p_waveOutGetVolume] end;
procedure waveOutMessage; asm JMP [p_waveOutMessage] end;
procedure waveOutOpen; asm JMP [p_waveOutOpen] end;
procedure waveOutPause; asm JMP [p_waveOutPause] end;
procedure waveOutPrepareHeader; asm JMP [p_waveOutPrepareHeader] end;
procedure waveOutReset; asm JMP [p_waveOutReset] end;
procedure waveOutRestart; asm JMP [p_waveOutRestart] end;
procedure waveOutSetPitch; asm JMP [p_waveOutSetPitch] end;
procedure waveOutSetPlaybackRate; asm JMP [p_waveOutSetPlaybackRate] end;
procedure waveOutSetVolume; asm JMP [p_waveOutSetVolume] end;
procedure waveOutUnprepareHeader; asm JMP [p_waveOutUnprepareHeader] end;
procedure waveOutWrite; asm JMP [p_waveOutWrite] end;
procedure wid32Message; asm JMP [p_wid32Message] end;
procedure wod32Message; asm JMP [p_wod32Message] end;

var
  FTrampolineGlobalHandle: function(Mem: Pointer): HGLOBAL; stdcall;

procedure Patch(Addr: Pointer);
type
  TByteArray = array[0..2] of Byte;
  PByteArray = ^TByteArray;
var
  oldProtect: DWORD;
begin
  VirtualProtect(Addr, 3, PAGE_READWRITE, oldProtect);
  PByteArray(Addr)^[0] := $90;
  PByteArray(Addr)^[1] := $90;
  PByteArray(Addr)^[2] := $90;
  VirtualProtect(Addr, 3, oldProtect, nil);
  FlushInstructionCache(GetCurrentProcess, Addr, 3);
  InterceptRemove(@FTrampolineGlobalHandle);
  @FTrampolineGlobalHandle := nil;
end;

function AltGlobalHandle(Mem: Pointer): HGLOBAL; stdcall;
asm
  PUSH Mem
  CALL [FTrampolineGlobalHandle]
  PUSH EAX

  MOV EAX,[EBP+4]
  MOV EDX,[EAX]
  CMP EDX,$8BC0B70F
  JNZ @@1
  CALL Patch
@@1:
  POP EAX
end;

procedure LibraryProc(Reason: Integer);
var
  path: array[0..MAX_PATH-1] of Char;
begin
  case Reason of
    DLL_PROCESS_ATTACH:
    begin
      GetSystemDirectory(@path, MAX_PATH);
      hLib := LoadLibrary(PChar(path + '\winmm.dll'));
      if hLib = 0 then Exit;
      p_CloseDriver := GetProcAddress(hLib, 'CloseDriver');
      p_DefDriverProc := GetProcAddress(hLib, 'DefDriverProc');
      p_DriverCallback := GetProcAddress(hLib, 'DriverCallback');
      p_DrvGetModuleHandle := GetProcAddress(hLib, 'DrvGetModuleHandle');
      p_GetDriverModuleHandle := GetProcAddress(hLib, 'GetDriverModuleHandle');
      p_NotifyCallbackData := GetProcAddress(hLib, 'NotifyCallbackData');
      p_OpenDriver := GetProcAddress(hLib, 'OpenDriver');
      p_PlaySound := GetProcAddress(hLib, 'PlaySound');
      p_PlaySoundA := GetProcAddress(hLib, 'PlaySoundA');
      p_PlaySoundW := GetProcAddress(hLib, 'PlaySoundW');
      p_SendDriverMessage := GetProcAddress(hLib, 'SendDriverMessage');
      p_WOW32DriverCallback := GetProcAddress(hLib, 'WOW32DriverCallback');
      p_WOW32ResolveMultiMediaHandle := GetProcAddress(hLib, 'WOW32ResolveMultiMediaHandle');
      p_WOWAppExit := GetProcAddress(hLib, 'WOWAppExit');
      p_aux32Message := GetProcAddress(hLib, 'aux32Message');
      p_auxGetDevCapsA := GetProcAddress(hLib, 'auxGetDevCapsA');
      p_auxGetDevCapsW := GetProcAddress(hLib, 'auxGetDevCapsW');
      p_auxGetNumDevs := GetProcAddress(hLib, 'auxGetNumDevs');
      p_auxGetVolume := GetProcAddress(hLib, 'auxGetVolume');
      p_auxOutMessage := GetProcAddress(hLib, 'auxOutMessage');
      p_auxSetVolume := GetProcAddress(hLib, 'auxSetVolume');
      p_joy32Message := GetProcAddress(hLib, 'joy32Message');
      p_joyConfigChanged := GetProcAddress(hLib, 'joyConfigChanged');
      p_joyGetDevCapsA := GetProcAddress(hLib, 'joyGetDevCapsA');
      p_joyGetDevCapsW := GetProcAddress(hLib, 'joyGetDevCapsW');
      p_joyGetNumDevs := GetProcAddress(hLib, 'joyGetNumDevs');
      p_joyGetPos := GetProcAddress(hLib, 'joyGetPos');
      p_joyGetPosEx := GetProcAddress(hLib, 'joyGetPosEx');
      p_joyGetThreshold := GetProcAddress(hLib, 'joyGetThreshold');
      p_joyReleaseCapture := GetProcAddress(hLib, 'joyReleaseCapture');
      p_joySetCapture := GetProcAddress(hLib, 'joySetCapture');
      p_joySetThreshold := GetProcAddress(hLib, 'joySetThreshold');
      p_mci32Message := GetProcAddress(hLib, 'mci32Message');
      p_mciDriverNotify := GetProcAddress(hLib, 'mciDriverNotify');
      p_mciDriverYield := GetProcAddress(hLib, 'mciDriverYield');
      p_mciExecute := GetProcAddress(hLib, 'mciExecute');
      p_mciFreeCommandResource := GetProcAddress(hLib, 'mciFreeCommandResource');
      p_mciGetCreatorTask := GetProcAddress(hLib, 'mciGetCreatorTask');
      p_mciGetDeviceIDA := GetProcAddress(hLib, 'mciGetDeviceIDA');
      p_mciGetDeviceIDFromElementIDA := GetProcAddress(hLib, 'mciGetDeviceIDFromElementIDA');
      p_mciGetDeviceIDFromElementIDW := GetProcAddress(hLib, 'mciGetDeviceIDFromElementIDW');
      p_mciGetDeviceIDW := GetProcAddress(hLib, 'mciGetDeviceIDW');
      p_mciGetDriverData := GetProcAddress(hLib, 'mciGetDriverData');
      p_mciGetErrorStringA := GetProcAddress(hLib, 'mciGetErrorStringA');
      p_mciGetErrorStringW := GetProcAddress(hLib, 'mciGetErrorStringW');
      p_mciGetYieldProc := GetProcAddress(hLib, 'mciGetYieldProc');
      p_mciLoadCommandResource := GetProcAddress(hLib, 'mciLoadCommandResource');
      p_mciSendCommandA := GetProcAddress(hLib, 'mciSendCommandA');
      p_mciSendCommandW := GetProcAddress(hLib, 'mciSendCommandW');
      p_mciSendStringA := GetProcAddress(hLib, 'mciSendStringA');
      p_mciSendStringW := GetProcAddress(hLib, 'mciSendStringW');
      p_mciSetDriverData := GetProcAddress(hLib, 'mciSetDriverData');
      p_mciSetYieldProc := GetProcAddress(hLib, 'mciSetYieldProc');
      p_mid32Message := GetProcAddress(hLib, 'mid32Message');
      p_midiConnect := GetProcAddress(hLib, 'midiConnect');
      p_midiDisconnect := GetProcAddress(hLib, 'midiDisconnect');
      p_midiInAddBuffer := GetProcAddress(hLib, 'midiInAddBuffer');
      p_midiInClose := GetProcAddress(hLib, 'midiInClose');
      p_midiInGetDevCapsA := GetProcAddress(hLib, 'midiInGetDevCapsA');
      p_midiInGetDevCapsW := GetProcAddress(hLib, 'midiInGetDevCapsW');
      p_midiInGetErrorTextA := GetProcAddress(hLib, 'midiInGetErrorTextA');
      p_midiInGetErrorTextW := GetProcAddress(hLib, 'midiInGetErrorTextW');
      p_midiInGetID := GetProcAddress(hLib, 'midiInGetID');
      p_midiInGetNumDevs := GetProcAddress(hLib, 'midiInGetNumDevs');
      p_midiInMessage := GetProcAddress(hLib, 'midiInMessage');
      p_midiInOpen := GetProcAddress(hLib, 'midiInOpen');
      p_midiInPrepareHeader := GetProcAddress(hLib, 'midiInPrepareHeader');
      p_midiInReset := GetProcAddress(hLib, 'midiInReset');
      p_midiInStart := GetProcAddress(hLib, 'midiInStart');
      p_midiInStop := GetProcAddress(hLib, 'midiInStop');
      p_midiInUnprepareHeader := GetProcAddress(hLib, 'midiInUnprepareHeader');
      p_midiOutCacheDrumPatches := GetProcAddress(hLib, 'midiOutCacheDrumPatches');
      p_midiOutCachePatches := GetProcAddress(hLib, 'midiOutCachePatches');
      p_midiOutClose := GetProcAddress(hLib, 'midiOutClose');
      p_midiOutGetDevCapsA := GetProcAddress(hLib, 'midiOutGetDevCapsA');
      p_midiOutGetDevCapsW := GetProcAddress(hLib, 'midiOutGetDevCapsW');
      p_midiOutGetErrorTextA := GetProcAddress(hLib, 'midiOutGetErrorTextA');
      p_midiOutGetErrorTextW := GetProcAddress(hLib, 'midiOutGetErrorTextW');
      p_midiOutGetID := GetProcAddress(hLib, 'midiOutGetID');
      p_midiOutGetNumDevs := GetProcAddress(hLib, 'midiOutGetNumDevs');
      p_midiOutGetVolume := GetProcAddress(hLib, 'midiOutGetVolume');
      p_midiOutLongMsg := GetProcAddress(hLib, 'midiOutLongMsg');
      p_midiOutMessage := GetProcAddress(hLib, 'midiOutMessage');
      p_midiOutOpen := GetProcAddress(hLib, 'midiOutOpen');
      p_midiOutPrepareHeader := GetProcAddress(hLib, 'midiOutPrepareHeader');
      p_midiOutReset := GetProcAddress(hLib, 'midiOutReset');
      p_midiOutSetVolume := GetProcAddress(hLib, 'midiOutSetVolume');
      p_midiOutShortMsg := GetProcAddress(hLib, 'midiOutShortMsg');
      p_midiOutUnprepareHeader := GetProcAddress(hLib, 'midiOutUnprepareHeader');
      p_midiStreamClose := GetProcAddress(hLib, 'midiStreamClose');
      p_midiStreamOpen := GetProcAddress(hLib, 'midiStreamOpen');
      p_midiStreamOut := GetProcAddress(hLib, 'midiStreamOut');
      p_midiStreamPause := GetProcAddress(hLib, 'midiStreamPause');
      p_midiStreamPosition := GetProcAddress(hLib, 'midiStreamPosition');
      p_midiStreamProperty := GetProcAddress(hLib, 'midiStreamProperty');
      p_midiStreamRestart := GetProcAddress(hLib, 'midiStreamRestart');
      p_midiStreamStop := GetProcAddress(hLib, 'midiStreamStop');
      p_mixerClose := GetProcAddress(hLib, 'mixerClose');
      p_mixerGetControlDetailsA := GetProcAddress(hLib, 'mixerGetControlDetailsA');
      p_mixerGetControlDetailsW := GetProcAddress(hLib, 'mixerGetControlDetailsW');
      p_mixerGetDevCapsA := GetProcAddress(hLib, 'mixerGetDevCapsA');
      p_mixerGetDevCapsW := GetProcAddress(hLib, 'mixerGetDevCapsW');
      p_mixerGetID := GetProcAddress(hLib, 'mixerGetID');
      p_mixerGetLineControlsA := GetProcAddress(hLib, 'mixerGetLineControlsA');
      p_mixerGetLineControlsW := GetProcAddress(hLib, 'mixerGetLineControlsW');
      p_mixerGetLineInfoA := GetProcAddress(hLib, 'mixerGetLineInfoA');
      p_mixerGetLineInfoW := GetProcAddress(hLib, 'mixerGetLineInfoW');
      p_mixerGetNumDevs := GetProcAddress(hLib, 'mixerGetNumDevs');
      p_mixerMessage := GetProcAddress(hLib, 'mixerMessage');
      p_mixerOpen := GetProcAddress(hLib, 'mixerOpen');
      p_mixerSetControlDetails := GetProcAddress(hLib, 'mixerSetControlDetails');
      p_mmDrvInstall := GetProcAddress(hLib, 'mmDrvInstall');
      p_mmGetCurrentTask := GetProcAddress(hLib, 'mmGetCurrentTask');
      p_mmTaskBlock := GetProcAddress(hLib, 'mmTaskBlock');
      p_mmTaskCreate := GetProcAddress(hLib, 'mmTaskCreate');
      p_mmTaskSignal := GetProcAddress(hLib, 'mmTaskSignal');
      p_mmTaskYield := GetProcAddress(hLib, 'mmTaskYield');
      p_mmioAdvance := GetProcAddress(hLib, 'mmioAdvance');
      p_mmioAscend := GetProcAddress(hLib, 'mmioAscend');
      p_mmioClose := GetProcAddress(hLib, 'mmioClose');
      p_mmioCreateChunk := GetProcAddress(hLib, 'mmioCreateChunk');
      p_mmioDescend := GetProcAddress(hLib, 'mmioDescend');
      p_mmioFlush := GetProcAddress(hLib, 'mmioFlush');
      p_mmioGetInfo := GetProcAddress(hLib, 'mmioGetInfo');
      p_mmioInstallIOProcA := GetProcAddress(hLib, 'mmioInstallIOProcA');
      p_mmioInstallIOProcW := GetProcAddress(hLib, 'mmioInstallIOProcW');
      p_mmioOpenA := GetProcAddress(hLib, 'mmioOpenA');
      p_mmioOpenW := GetProcAddress(hLib, 'mmioOpenW');
      p_mmioRead := GetProcAddress(hLib, 'mmioRead');
      p_mmioRenameA := GetProcAddress(hLib, 'mmioRenameA');
      p_mmioRenameW := GetProcAddress(hLib, 'mmioRenameW');
      p_mmioSeek := GetProcAddress(hLib, 'mmioSeek');
      p_mmioSendMessage := GetProcAddress(hLib, 'mmioSendMessage');
      p_mmioSetBuffer := GetProcAddress(hLib, 'mmioSetBuffer');
      p_mmioSetInfo := GetProcAddress(hLib, 'mmioSetInfo');
      p_mmioStringToFOURCCA := GetProcAddress(hLib, 'mmioStringToFOURCCA');
      p_mmioStringToFOURCCW := GetProcAddress(hLib, 'mmioStringToFOURCCW');
      p_mmioWrite := GetProcAddress(hLib, 'mmioWrite');
      p_mmsystemGetVersion := GetProcAddress(hLib, 'mmsystemGetVersion');
      p_mod32Message := GetProcAddress(hLib, 'mod32Message');
      p_mxd32Message := GetProcAddress(hLib, 'mxd32Message');
      p_sndPlaySoundA := GetProcAddress(hLib, 'sndPlaySoundA');
      p_sndPlaySoundW := GetProcAddress(hLib, 'sndPlaySoundW');
      p_tid32Message := GetProcAddress(hLib, 'tid32Message');
      p_timeBeginPeriod := GetProcAddress(hLib, 'timeBeginPeriod');
      p_timeEndPeriod := GetProcAddress(hLib, 'timeEndPeriod');
      p_timeGetDevCaps := GetProcAddress(hLib, 'timeGetDevCaps');
      p_timeGetSystemTime := GetProcAddress(hLib, 'timeGetSystemTime');
      p_timeGetTime := GetProcAddress(hLib, 'timeGetTime');
      p_timeKillEvent := GetProcAddress(hLib, 'timeKillEvent');
      p_timeSetEvent := GetProcAddress(hLib, 'timeSetEvent');
      p_waveInAddBuffer := GetProcAddress(hLib, 'waveInAddBuffer');
      p_waveInClose := GetProcAddress(hLib, 'waveInClose');
      p_waveInGetDevCapsA := GetProcAddress(hLib, 'waveInGetDevCapsA');
      p_waveInGetDevCapsW := GetProcAddress(hLib, 'waveInGetDevCapsW');
      p_waveInGetErrorTextA := GetProcAddress(hLib, 'waveInGetErrorTextA');
      p_waveInGetErrorTextW := GetProcAddress(hLib, 'waveInGetErrorTextW');
      p_waveInGetID := GetProcAddress(hLib, 'waveInGetID');
      p_waveInGetNumDevs := GetProcAddress(hLib, 'waveInGetNumDevs');
      p_waveInGetPosition := GetProcAddress(hLib, 'waveInGetPosition');
      p_waveInMessage := GetProcAddress(hLib, 'waveInMessage');
      p_waveInOpen := GetProcAddress(hLib, 'waveInOpen');
      p_waveInPrepareHeader := GetProcAddress(hLib, 'waveInPrepareHeader');
      p_waveInReset := GetProcAddress(hLib, 'waveInReset');
      p_waveInStart := GetProcAddress(hLib, 'waveInStart');
      p_waveInStop := GetProcAddress(hLib, 'waveInStop');
      p_waveInUnprepareHeader := GetProcAddress(hLib, 'waveInUnprepareHeader');
      p_waveOutBreakLoop := GetProcAddress(hLib, 'waveOutBreakLoop');
      p_waveOutClose := GetProcAddress(hLib, 'waveOutClose');
      p_waveOutGetDevCapsA := GetProcAddress(hLib, 'waveOutGetDevCapsA');
      p_waveOutGetDevCapsW := GetProcAddress(hLib, 'waveOutGetDevCapsW');
      p_waveOutGetErrorTextA := GetProcAddress(hLib, 'waveOutGetErrorTextA');
      p_waveOutGetErrorTextW := GetProcAddress(hLib, 'waveOutGetErrorTextW');
      p_waveOutGetID := GetProcAddress(hLib, 'waveOutGetID');
      p_waveOutGetNumDevs := GetProcAddress(hLib, 'waveOutGetNumDevs');
      p_waveOutGetPitch := GetProcAddress(hLib, 'waveOutGetPitch');
      p_waveOutGetPlaybackRate := GetProcAddress(hLib, 'waveOutGetPlaybackRate');
      p_waveOutGetPosition := GetProcAddress(hLib, 'waveOutGetPosition');
      p_waveOutGetVolume := GetProcAddress(hLib, 'waveOutGetVolume');
      p_waveOutMessage := GetProcAddress(hLib, 'waveOutMessage');
      p_waveOutOpen := GetProcAddress(hLib, 'waveOutOpen');
      p_waveOutPause := GetProcAddress(hLib, 'waveOutPause');
      p_waveOutPrepareHeader := GetProcAddress(hLib, 'waveOutPrepareHeader');
      p_waveOutReset := GetProcAddress(hLib, 'waveOutReset');
      p_waveOutRestart := GetProcAddress(hLib, 'waveOutRestart');
      p_waveOutSetPitch := GetProcAddress(hLib, 'waveOutSetPitch');
      p_waveOutSetPlaybackRate := GetProcAddress(hLib, 'waveOutSetPlaybackRate');
      p_waveOutSetVolume := GetProcAddress(hLib, 'waveOutSetVolume');
      p_waveOutUnprepareHeader := GetProcAddress(hLib, 'waveOutUnprepareHeader');
      p_waveOutWrite := GetProcAddress(hLib, 'waveOutWrite');
      p_wid32Message := GetProcAddress(hLib, 'wid32Message');
      p_wod32Message := GetProcAddress(hLib, 'wod32Message');

      @FTrampolineGlobalHandle := InterceptCreate(GetProcAddress(GetModuleHandle(kernel32), 'GlobalHandle'), @AltGlobalHandle);
    end;
    DLL_THREAD_ATTACH:
      ;
    DLL_THREAD_DETACH:
      ;
    DLL_PROCESS_DETACH:
    begin
      if @FTrampolineGlobalHandle <> nil then
        InterceptRemove(@FTrampolineGlobalHandle);
      if hLib <> 0 then
        FreeLibrary(hLib);
    end;
  end;
end;

exports
{$WARN SYMBOL_PLATFORM OFF}
  CloseDriver index 4,
  DefDriverProc index 5,
  DriverCallback index 6,
  DrvGetModuleHandle index 7,
  GetDriverModuleHandle index 8,
  NotifyCallbackData index 9,
  OpenDriver index 10,
  PlaySound index 11,
  PlaySoundA index 12,
  PlaySoundW index 13,
  SendDriverMessage index 14,
  WOW32DriverCallback index 15,
  WOW32ResolveMultiMediaHandle index 16,
  WOWAppExit index 17,
  aux32Message index 18,
  auxGetDevCapsA index 19,
  auxGetDevCapsW index 20,
  auxGetNumDevs index 21,
  auxGetVolume index 22,
  auxOutMessage index 23,
  auxSetVolume index 24,
  joy32Message index 25,
  joyConfigChanged index 26,
  joyGetDevCapsA index 27,
  joyGetDevCapsW index 28,
  joyGetNumDevs index 29,
  joyGetPos index 30,
  joyGetPosEx index 31,
  joyGetThreshold index 32,
  joyReleaseCapture index 33,
  joySetCapture index 34,
  joySetThreshold index 35,
  mci32Message index 36,
  mciDriverNotify index 37,
  mciDriverYield index 38,
  mciExecute index 3,
  mciFreeCommandResource index 39,
  mciGetCreatorTask index 40,
  mciGetDeviceIDA index 41,
  mciGetDeviceIDFromElementIDA index 42,
  mciGetDeviceIDFromElementIDW index 43,
  mciGetDeviceIDW index 44,
  mciGetDriverData index 45,
  mciGetErrorStringA index 46,
  mciGetErrorStringW index 47,
  mciGetYieldProc index 48,
  mciLoadCommandResource index 49,
  mciSendCommandA index 50,
  mciSendCommandW index 51,
  mciSendStringA index 52,
  mciSendStringW index 53,
  mciSetDriverData index 54,
  mciSetYieldProc index 55,
  mid32Message index 56,
  midiConnect index 57,
  midiDisconnect index 58,
  midiInAddBuffer index 59,
  midiInClose index 60,
  midiInGetDevCapsA index 61,
  midiInGetDevCapsW index 62,
  midiInGetErrorTextA index 63,
  midiInGetErrorTextW index 64,
  midiInGetID index 65,
  midiInGetNumDevs index 66,
  midiInMessage index 67,
  midiInOpen index 68,
  midiInPrepareHeader index 69,
  midiInReset index 70,
  midiInStart index 71,
  midiInStop index 72,
  midiInUnprepareHeader index 73,
  midiOutCacheDrumPatches index 74,
  midiOutCachePatches index 75,
  midiOutClose index 76,
  midiOutGetDevCapsA index 77,
  midiOutGetDevCapsW index 78,
  midiOutGetErrorTextA index 79,
  midiOutGetErrorTextW index 80,
  midiOutGetID index 81,
  midiOutGetNumDevs index 82,
  midiOutGetVolume index 83,
  midiOutLongMsg index 84,
  midiOutMessage index 85,
  midiOutOpen index 86,
  midiOutPrepareHeader index 87,
  midiOutReset index 88,
  midiOutSetVolume index 89,
  midiOutShortMsg index 90,
  midiOutUnprepareHeader index 91,
  midiStreamClose index 92,
  midiStreamOpen index 93,
  midiStreamOut index 94,
  midiStreamPause index 95,
  midiStreamPosition index 96,
  midiStreamProperty index 97,
  midiStreamRestart index 98,
  midiStreamStop index 99,
  mixerClose index 100,
  mixerGetControlDetailsA index 101,
  mixerGetControlDetailsW index 102,
  mixerGetDevCapsA index 103,
  mixerGetDevCapsW index 104,
  mixerGetID index 105,
  mixerGetLineControlsA index 106,
  mixerGetLineControlsW index 107,
  mixerGetLineInfoA index 108,
  mixerGetLineInfoW index 109,
  mixerGetNumDevs index 110,
  mixerMessage index 111,
  mixerOpen index 112,
  mixerSetControlDetails index 113,
  mmDrvInstall index 114,
  mmGetCurrentTask index 115,
  mmTaskBlock index 116,
  mmTaskCreate index 117,
  mmTaskSignal index 118,
  mmTaskYield index 119,
  mmioAdvance index 120,
  mmioAscend index 121,
  mmioClose index 122,
  mmioCreateChunk index 123,
  mmioDescend index 124,
  mmioFlush index 125,
  mmioGetInfo index 126,
  mmioInstallIOProcA index 127,
  mmioInstallIOProcW index 128,
  mmioOpenA index 129,
  mmioOpenW index 130,
  mmioRead index 131,
  mmioRenameA index 132,
  mmioRenameW index 133,
  mmioSeek index 134,
  mmioSendMessage index 135,
  mmioSetBuffer index 136,
  mmioSetInfo index 137,
  mmioStringToFOURCCA index 138,
  mmioStringToFOURCCW index 139,
  mmioWrite index 140,
  mmsystemGetVersion index 141,
  mod32Message index 142,
  mxd32Message index 143,
  sndPlaySoundA index 144,
  sndPlaySoundW index 145,
  tid32Message index 146,
  timeBeginPeriod index 147,
  timeEndPeriod index 148,
  timeGetDevCaps index 149,
  timeGetSystemTime index 150,
  timeGetTime index 151,
  timeKillEvent index 152,
  timeSetEvent index 153,
  waveInAddBuffer index 154,
  waveInClose index 155,
  waveInGetDevCapsA index 156,
  waveInGetDevCapsW index 157,
  waveInGetErrorTextA index 158,
  waveInGetErrorTextW index 159,
  waveInGetID index 160,
  waveInGetNumDevs index 161,
  waveInGetPosition index 162,
  waveInMessage index 163,
  waveInOpen index 164,
  waveInPrepareHeader index 165,
  waveInReset index 166,
  waveInStart index 167,
  waveInStop index 168,
  waveInUnprepareHeader index 169,
  waveOutBreakLoop index 170,
  waveOutClose index 171,
  waveOutGetDevCapsA index 172,
  waveOutGetDevCapsW index 173,
  waveOutGetErrorTextA index 174,
  waveOutGetErrorTextW index 175,
  waveOutGetID index 176,
  waveOutGetNumDevs index 177,
  waveOutGetPitch index 178,
  waveOutGetPlaybackRate index 179,
  waveOutGetPosition index 180,
  waveOutGetVolume index 181,
  waveOutMessage index 182,
  waveOutOpen index 183,
  waveOutPause index 184,
  waveOutPrepareHeader index 185,
  waveOutReset index 186,
  waveOutRestart index 187,
  waveOutSetPitch index 188,
  waveOutSetPlaybackRate index 189,
  waveOutSetVolume index 190,
  waveOutUnprepareHeader index 191,
  waveOutWrite index 192,
  wid32Message index 193,
  wod32Message index 194;

begin
  DllProc := @LibraryProc;
  LibraryProc(DLL_PROCESS_ATTACH);
end.
